#include <iostream>
#include <vector>
#include "histogram.h"
using namespace std;

void static find_minmax(const vector<double> &numbers, double &min, double &max)
{
    min = numbers[0];
    max = numbers[0];
    for(double number : numbers)
    {
        if(number < min)
        {
            min = number;
        }
        if(number > max)
        {
            max = number;
        }
    }
    return;

}

std::vector<size_t> make_histogram(std::vector<double>& numbers, size_t bin_count)
{

    double min;
    double max;
    find_minmax (numbers, min, max);
    double bin_size = (max - min) / bin_count;
    vector<size_t> bins(bin_count);
    for (size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;
        for(size_t j = 0; (j < (bin_count - 1)) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count-1]++;
        }
    }
    return bins;
}
